# A CMake config file for the library, to be used by external projects


####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was mqt-core-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

####################################################################################

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}")

include(CMakeFindDependencyMacro)
find_dependency(nlohmann_json)
option(MQT_CORE_ZX_WITH_GMP "Library is configured to use GMP for ZX calculations"
       FALSE)
if(MQT_CORE_ZX_WITH_GMP)
  find_dependency(GMP)
endif()

option(MQT_CORE_ZX_SYSTEM_BOOST
       "Library is configured to use system Boost instead of the bundled Boost::multiprecision"
       FALSE)
if(MQT_CORE_ZX_SYSTEM_BOOST)
  find_dependency(Boost 1.80.0)
endif()

if(TARGET MQT::Core)
  return()
endif()

include("${CMAKE_CURRENT_LIST_DIR}/Cache.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/CompilerOptions.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/CompilerWarnings.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/PackageAddTest.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/PreventInSourceBuilds.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/Sanitizers.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/StandardProjectSettings.cmake")
include("${CMAKE_CURRENT_LIST_DIR}/mqt-core-targets.cmake")

if(NOT mqt-core_FIND_QUIETLY)
  message(STATUS "Found mqt-core version ${mqt-core_VERSION}")
endif()
